# -*- coding: utf-8 -*-
import sys
import cmath
import string
import re

def instr():
    arg = ''
    if len( sys.argv ) == 2 :    # ввод из команной строки
        arg = sys.argv[ 1 ]
    elif len( sys.argv ) > 2 : 
        print( "ошибка формата команды!" )
        quit( 1 )
    else:                        # ввод из SYSIN
        while( True ):
            s = sys.stdin.readline()
            if s == '': break
            arg += ' ' + s            
    return arg


def polygon( s ):
    lst = s.split( ' ' )
    parms = []
    for i in range( len( lst ) ):
        if lst[ i ] == '': continue
        tmatch = re.search( r'\[(.*?),(.*?)\]', lst[ i ] )
        if not tmatch: continue
        try:
            p = complex( float( tmatch.group( 1 ) ), float( tmatch.group( 2 ) ) )
        except ValueError:
            continue
        parms.append( p )
    return parms;

if __name__ == '__main__':
    si = instr()
    print( 'ввод: {}'.format( si ) )
    pts = polygon( si )
    msg = 'введено {} : '.format( len( pts ) )
    for i in range( len( pts ) ):
        msg += '{} '.format( pts[ i ] )
    print( msg )


