#include <stdlib.h>
#include <complex>
#include <iostream>

using namespace std;


class point : public complex<double> {   // класс вершины наследуемый от complex 
protected:
   point( void ) {
      *(complex<double>*)this = complex<double>( 0, 0 );
   }
   point( const complex<double>& c ) { 
      *(complex<double>*)this = c;
   }
public:
   friend class triangle;
   friend ostream& operator << ( ostream& stream, point& obj );
   friend istream& operator >> ( istream& stream, point& obj );
};

inline ostream& operator << ( ostream& stream, point& obj ) {
   stream << "[" <<  obj.real() << "," << obj.imag() << "]"; 
   return stream;
};

inline istream& operator >> ( istream& stream, point& obj ) {
   double x, y;       
   string s;
   cin >> x >> y;
   getline( cin, s ); 
   obj = point( complex<double>( x, y ) ); 
   return stream; 
};

const int NODES = 3;                     // число вершин

class triangle {                         // класс треугольник производный от point
protected:
   point pt[ NODES ];
public:
   double perimeter( void ) {
      double summa = 0.0;
      int i, j;
      for( i = 0; i < NODES; i++ ) {
         j = NODES - 1 == i ? 0 : i + 1;
         summa += abs( pt[ i ] - pt[ j ] );
      } 
      return summa;
   }
   double square( void ) {
      complex<double> side1 = pt[ 1 ] - pt[ 0 ],
                      side2 = pt[ 2 ] - pt[ 0 ];
      return abs( side1 ) * abs( side2 ) * 
             fabs( sin( arg( side1 ) - arg( side2 ) ) ) / 2.; 
   }
   inline point& operator [] ( int i ) { return pt[ i ]; }
   friend istream& operator >> ( istream& stream, triangle& obj ) {
      for( int i = 0; i < NODES; i++ ) {
         cout << "вершина № " << i + 1 << " : " << flush;
         stream >> obj.pt[ i ];
         if( stream.eof() ) return stream;
      }
      return stream; 
   }
};

int main( int argc, char **argv, char **envp ) {
   cout.precision( 3 );
   while( 1 ) {
      int i = 0;
      triangle polygon;
      cout << "координаты вершин в формате: X Y" << endl;
      if( ( cin >> polygon ).eof() )
         cout << "завершение работы" << endl, exit( EXIT_SUCCESS );
      cout << "вершин " << NODES << " : ";
      for( i = 0; i < NODES; i++ ) 
         cout << polygon[ i ] << " ";
      cout <<  endl << "периметр = " <<  polygon.perimeter() << endl
           << "площадь = " <<  polygon.square() << endl
           << "---------------------------------" << endl; 
   }
}
