#!/usr/bin/guile -s
!#
 
(import (rnrs io ports (6)))
 
(setlocale LC_ALL "")
 
(define (point)
  (let ((numbers (string-split
                  (get-line (current-input-port)) #\space)))
    (if (not (eq? (length numbers) 2)) #f
        (let ((x (string->number (car numbers)))
              (y (string->number (cadr numbers))))
          (+ x (* y 0+1i))))))
 
(define (poligon)
  (let loop ((n 1) (points '()))
    (format #t "вершина № ~a : " n)
    (let ((p (point)))
      (if p (loop (+ n 1) (cons p points)) points))))
     
(define (perimeter lst)
  (define (size p1 p2)
    (magnitude (- p1 p2)))
  (let ((head (car lst)))
    (let ploop((z lst) (per 0.0))
      (if (null? (cdr z))
          (+ (size (car z) head) per)
          (ploop (cdr z) (+ (size (car z) (cadr z)) per))))))
 
(define (square lst)
  (let ((shead (car lst)))
    (let sloop((z (cdr lst))
               (squ 0.0))
      (if (null? (cdr z )) squ
          (sloop (cdr z)
                 (+ (let ((s1 (- (car z) shead))
                          (s2 (- (cadr z) shead)))
                      (* (* (abs (sin (- (angle s2) (angle s1)))) 0.5)
                         (* (magnitude s1) (magnitude s2))))
                    squ))))))
 
(define (next)
  (define (d2 f) (/ (round (* f 100.0)) 100.0))
  (format #t "координаты вершин в формате: X Y\n")
  (let ((shape (poligon)))
    (when (> (length shape) 1)
      (format #t "\nвершин ~a : " (length shape))
      (for-each (lambda (x)
                  (format #t "[~a,~a] "
                          (d2 (real-part x))
                          (d2 (imag-part x))))
                shape)
      (format #t "\nпериметр = ~a\n" (d2 (perimeter shape)))
      (format #t "площадь = ~a\n" (d2 (square shape)))
      (display "---------------------------------\n")
      (next))))
 
(next)
