#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <complex.h>
#include <string.h>

/* рассчёт параметров треугольника */
#define NODES 3                                // число вершин 
typedef  double complex triangle_t [ NODES ];  // тип треугольника

static double perimeter( triangle_t pts ) {
   double summa = 0.0;
   int i, j;
   for( i = 0; i < NODES; i++ ) {
      j = NODES - 1 == i ? 0 : i + 1;
      summa += cabs( pts[ i ] - pts[ j ] );
   }
   return summa;
}

static double square( triangle_t pts ) {
   double complex side1 = pts[ 1 ] - pts[ 0 ],
                  side2 = pts[ 2 ] - pts[ 0 ];
   return cabs( side1 ) * cabs( side2 ) * 
          fabs( sin( carg( side1 ) - carg( side2 ) ) ) / 2.; 
}

#define INLEN 40
int main( int argc, char **argv, char **envp ) {
   while( 1 ) {
      int i = 0;
      triangle_t polygon;
      printf( "координаты вершин в формате: X Y\n" );
      while( i < NODES ) {
         float x, y;       
         printf( "вершина № %d: ", i + 1 );
         fflush( stdout );
         char s[ INLEN ], e[ INLEN ];
         if( !fgets( s, sizeof( s ) - 1, stdin ) ) // строка ввода
            printf( "завершение\n" ), exit( EXIT_SUCCESS );
         s[ strlen( s ) - 1 ] = '\0';              // удалить EOL
         while( ' ' == s[ strlen( s ) - 1 ] )      // удалить хвостовые пробелы
            s[ strlen( s ) - 1 ] = '\0';
         if( sscanf( s, "%f%*c%f%s", &x, &y, (char*)&e ) != 2 ) {
            printf( "ошибка ввода!\n" );
            continue;
         }
         polygon[ i++ ] = x + I * y;
      }
      printf( "вершин %d : ", NODES );
      for( i = 0; i < NODES; i++ ) 
         printf( "[%.2f,%.2f] ",
                 creal( polygon[ i ] ), cimag( polygon[ i ] ) );
      printf( "\nпериметр = %.2f\nплощадь = %.2f\n"
              "---------------------------------\n",
              perimeter( polygon ), square( polygon ) ); 
   }
}
