#!/usr/bin/js 

function Complex( re, im ) {  // конструктор
   this.x = re; this.y = im;
}

// определение методов экземпляра в объекте-прототипе конструктора ...
Complex.prototype.abs = function() {
   return Math.sqrt( this.x * this.x + this.y * this.y );
}

Complex.prototype.arg = function() {
   return Math.atan2( this.y, this.x );
}

Complex.prototype.sub = function( that ) {
   return new Complex( this.x - that.x, this.y - that.y );
}

Complex.prototype.toString = function() {
   return " [" + this.x.toFixed( 2 ) + "," + this.y.toFixed( 2 ) + "]";
}

Complex.sub = function( a, b ) {      // определение методов класса (static, friend)
   return new Complex( a.x - b.x, a.y - b.y );
}

var perimeter = function( triang ) {  // функциональные литералы
       var summa = 0.0;
       for( i = 0; i < triang.length; i++ ) 
          summa += Complex.sub( triang[ i ],
                   triang[ i == 0 ? triang.length - 1 : i - 1 ] ).abs();
       return summa;
    },
    square  = function( triang ) {
       var summa = 0.0;
       for( i = 0; i < triang.length - 2; i++ ) {
          side1 = triang[ i + 1 ].sub( triang[ 0 ] );
          side2 = triang[ i + 2 ].sub( triang[ 0 ] );
          summa += side1.abs() * side2.abs() *
                   Math.abs( Math.sin( side1.arg() - side2.arg() ) ) / 2.;
       }
       return summa
    };

while( true ) {
   print( "координаты вершин в формате: X Y (^D конец ввода)" );
   var i = 0; 
   var polygon = new Array();
   while( true ) {
      putstr( "вершина №" + ( i + 1 ) + " : " );
      var s = readline();
      if( s === null ) {       // ^D
         putstr( "\r" ); 
         break;
      }
      var ws = s.split( ' ' );
      if( ws.length !== 2 ||
          isNaN( x = parseFloat( ws[ 0 ] ) ) ||
          isNaN( y = parseFloat( ws[ 1 ] ) ) ) {
         print( "ошибка ввода!" );
         continue;
      }
      polygon[ i++ ] = new Complex( x, y );
      delete x; delete y;
   }
   s = "вершин " + polygon.length + " :";
   for( i in polygon ) s += polygon[ i ];
   print( s ); 
   print( "периметр = " + perimeter( polygon ).toFixed( 2 ) );
   print( "площадь = " + square( polygon ).toFixed( 2 ) );
   print( "---------------------------------" );
}

// JS API: https://developer.mozilla.org/en-US/docs/SpiderMonkey/Introduction_to_the_JavaScript_shell 
