import java.io.*
import java.util.*
import java.lang.Double.*

internal class Polygon : ArrayList<Complex>() {        // class Complex заимствуется из отдельного файла
    override fun toString(): String {
        var ret = ""
        for (i in 0..size - 1)
            ret += "[" + get(i).re.toString() + "," +
                    get(i).im.toString() + "] "
        return ret
    }

    fun perimeter(): Double {
        var summa = 0.0
        for (i in 0..size - 1)
            summa += get(i).minus(if (i != size - 1) get(i + 1) else get(0)).r()
        return summa
    }

    fun square(): Double {
        var summa = 0.0
        for (i in 1..size - 1 - 1) {
            val side1 = get(i).minus(get(0))
            val side2 = get(i + 1).minus(get(0))
            summa += side1.r() * side2.r() *
                    Math.abs(Math.sin(side1.theta() - side2.theta())) / 2.0
        }
        return summa
    }
}

object triangle {
    @JvmStatic fun main(args: Array<String>) {
        val `in` = Scanner(System.`in`)      // создание объекта чтения из стандартного потока ввода
        while (true) {
            println("координаты вершин в формате: X Y")
            val polygon = Polygon()
            var coord = ""
            while (true) {
                System.out.printf("%s%d%s", "вершина № ", polygon.size + 1, " : ")
                try {
                    coord = `in`.nextLine()
                }        // чтение строки из консоли
                catch (ex: java.util.NoSuchElementException) {
                    println("завершение работы")
                    System.exit(0)                  // EOF: ^D
                }
                if (0 == coord.length)
                    if (polygon.size != 0)
                        break   // завершение многоугольника
                    else {
                        println("завершение работы")
                        System.exit(0)
                    }
                try {                                 // выделение координат
                    val st = StringTokenizer(coord, " \t\n")
                    val x: Double? = (st.nextElement() as String).toDouble()
                    val y: Double? = (st.nextElement() as String).toDouble()
                    polygon.add(Complex(x!!, y!!))
                } catch (ex: java.util.NoSuchElementException) {
                    println("ошибка ввода!: " + ex.toString())
                    continue
                } catch (ex: java.lang.NumberFormatException) {
                    println("ошибка формата!: " + ex.toString())
                    continue
                }
            }
            println("вершин " + polygon.size + " : " + polygon)
            println("периметр = " + polygon.perimeter())
            println("площадь = " + polygon.square())
            println("---------------------------------")
        }
    }
}

