#!/usr/bin/lua

-- https://github.com/davidm/lua-matrix/blob/master/lua/complex.lua
local complex = require 'complex'

inpoint = function( prompt ) 
   io.write( prompt )
   local s = io.read ()                        -- чтение пары координат
   if( s == nil ) then                         -- ^D конец ввода многоугольника
      print '\r'
      return true
   end
   local res = {}
   for w in string.gmatch( s, "%S+" ) do
      table.insert( res, w )
   end
   if( #res ~= 2 ) then return nil; end        -- только 2 поля ввода: x & y
   local ret, x = pcall( string.format, "%e", res[ 1 ] )
   if( not ret ) then return nil; end
   local ret, y = pcall( string.format, "%e", res[ 2 ] )
   if( not ret ) then return nil; end
   return x, y -- nil если не число
end

local perimeter = function( triang )           -- функциональный литерал
         local function length( p1, p2 )       -- вложенная функция
            n, t =  complex.polar( p2 - p1 )
            return n
         end
         local suma = 0.0
         for i, v in ipairs( triang ) do
            if( i == 1 ) then j = #triang 
            else j = i - 1
            end
            suma = suma + length( triang[ i ], triang[ j ] ) 
         end
         return suma
      end

local square = function( triang )              -- функциональный литерал
         local suma = 0.0
         for i = 1, #triang - 2, 1 do
            -- таблица triang индексируется с 1: n = re, t = im
            local n1, t1 = complex.polar( triang[ i + 1 ] - triang[ 1 ] )
            local n2, t2 = complex.polar( triang[ i + 2 ] - triang[ 1 ] )
            suma = suma + n1 * n2 * math.abs( math.sin( t2 - t1 ) ) / 2.;
         end
         return suma
      end

while true do
   print( 'координаты вершин в формате: X Y (^D конец ввода)' )
   local polygon = {}                                     -- пустая таблица - многогольник
   local i = 0
   while true do
      x, y = inpoint( 'вершина №' .. ( i + 1 ) .. ' : ' )
      if( not x ) then print 'ошибка ввода!'              -- nil == false
      elseif ( type( x ) == 'boolean' and x ) then break  -- EOF - конец ввода
      else
         polygon[ i + 1 ] = complex.new( x, y )           -- добавить (!) вершину
         i = i + 1
      end
   end
   io.write( 'вершин ' .. #polygon .. ' :' )
   for i, v in ipairs( polygon ) do
      local msg = " [" .. string.format( "%.2f", v[ 1 ] ) 
      msg = msg .. "," .. string.format( "%.2f", v[ 2 ] ) .."]"
      io.write( msg ) 
   end
   print ''
   print( 'периметр = ' .. string.format( "%.2f", perimeter( polygon ) ) )
   print( 'площадь = ' .. string.format( "%.2f",square( polygon ) ) )
   print "---------------------------------"
end 

--[[ а это многострочный комментарий:
http://lua-users.org/wiki/TutorialDirectory
http://www.lua.org/docs.html
http://www.lua.ru/doc/

http://symmetrica.net/lua/lua1.pdf
http://symmetrica.net/lua/lua2.pdf
http://symmetrica.net/lua/lua3.pdf
http://symmetrica.net/lua/lua4.pdf
--]]
