#!/usr/bin/php
<?php

class Complex {
   var $x, $y;
   function __construct( $re, $im ) {     // конструктор
      $this->x = $re;
      $this->y = $im;
   }
   function abs() {
      return sqrt( $this->x * $this->x + $this->y * $this->y );
   }
   function arg() {
      return atan2( $this->y, $this->x );
   }
   function sub( $that ) {
      return new Complex( $this->x - $that->x, $this->y - $that->y );
   }
}

class Point extends Complex {             // конструктор
   function toString() {
      $s = sprintf( "[%.2f,%.2f] ", $this->x, $this->y );
      return $s;
   }
}

function perimeter( $triang ) {
   $sum = 0.0;
   for( $i = 0; $i < sizeof( $triang ); $i++ ) { 
      $j = $i == 0 ? sizeof( $triang ) - 1 : $i - 1;
      $sum += $triang[ $i ]->sub( $triang[ $j ] )->abs();
   }
   return $sum;
}

function square( $triang ) {
   $sum = 0.0;
   for( $i = 0; $i < sizeof( $triang ) - 2; $i++ ) { 
      $side1 = $triang[ $i + 1 ]->sub( $triang[ 0 ] );
      $side2 = $triang[ $i + 2 ]->sub( $triang[ 0 ] );
      $sum += $side1->abs() * $side2->abs() *
              abs( sin( $side1->arg() - $side2->arg() ) ) / 2.;
   }
   return $sum;
}

while( TRUE ) {
   print "координаты вершин в формате: X Y (^D конец ввода)\n";
   $polygon = array();   // динамический массив - образ многоугольника
   $i = 0;
   while( TRUE ) {
      echo "вершина № ", ( $i + 1 ), " : ";
      $line = stream_get_line( STDIN, 1024, PHP_EOL );
      if( strlen( $line ) == 0 ) {       // ^D - конец ввода многоугольника
         echo "\r";
         break;  
      }
      $pieces = explode( " ", $line );
      if( sizeof( $pieces ) != 2 ) {
         echo "ошибка ввода!\n";
         continue;
      }
      $fmask = "+-0123456789.Ee"; 
      if( 0 == strspn( $pieces[ 0 ], $fmask ) || 0 == strspn( $pieces[ 1 ], $fmask ) ) {
         echo "ошибка ввода\n";
         continue;
      }
      $polygon[] = new Point( (float)$pieces[ 0 ], (float)$pieces[ 1 ] ); // дополнение! в массив
      $i++;
   }
   $s = "вершин " . sizeof( $polygon ) . " : ";
   for( $i = 0; $i < sizeof( $polygon ); $i++ )
      $s .= $polygon[ $i ]->toString();
   echo $s, "\n";
   printf( "периметр = %.2f\n", perimeter( $polygon ) );
   printf( "площадь = %.2f\n", square( $polygon ) );
   print "---------------------------------\n";
} 

/* http://www.php.net/manual/en/features.commandline.php
   http://ru2.php.net/manual/ru/
   http://ru2.php.net/manual/ru/funcref.php
*/

?>
