#!/usr/bin/ruby
# coding: utf-8

=begin
вариант Ruby:
- вершины многоугольника - class Point
- многоугольник - class Shape
=end

class Point
   def initialize( re, im )
      @z = Complex( re, im )
   end
   def to_s
      "[" + @z.real.to_s + "," + @z.imag.to_s + "] "
   end
   def abs() @z.abs end
   def arg() @z.arg end
   def-(another)
      @z - another.get
   end
protected
   def get() @z end
end

class Shape                  # класс многоугольника
   def initialize
      @points = []
   end
   def clean
      @points = []
   end
   def add val               # добавление вершины
      @points[ @points.size ] = val
   end 
   def size                  # размерность многоугольника
      @points.size
   end 
   def to_s
      msg = ""
      @points.each do |point|
         msg +=  point.to_s
      end
      msg
   end 
   def perimeter
      summa = 0.0;
      for i in 0..( @points.size - 1 )
         if i == 0 then j = @points.size - 1
         else j = i - 1 
         end
         summa += ( @points[ i ] - @points[ j ] ).abs
      end
      summa
   end 
   def square
      summa = 0.0
      for i in 0..( @points.size - 3 )
         s1 = @points[ i + 1 ] - @points[ 0 ]
         s2 = @points[ i + 2 ] - @points[ 0 ]
         summa += 0.5 * s1.abs * s2.abs * Math.sin( s2.arg - s1.arg ).abs
      end
      summa
   end
end

shape = Shape.new()
while true do
   puts( 'координаты вершин в формате: X Y (^D конец ввода)' )
   i = 1
   shape.clean
   while true do
      print "вершина № #{i.to_s} : "
      if ( ansv = gets ) == nil then
         print "\r"
         break
      end
      ansv.chop!.strip!
      m = ansv.split(/ /)
      if ( n =  m.size ) != 2 ||
         m[ 0 ] !~ /\d+\.{0,1}\d*$/ ||
         m[ 1 ] !~ /\d+\.{0,1}\d*$/ then
         puts "ошибка ввода!"
         next
      end
      shape.add( Point.new( m[ 0 ].to_f, m[ 1 ].to_f ) )
      i += 1 
   end
   printf( "вершин %s : %s\n", shape.size.to_s, shape.to_s )
   printf( "периметр = %.2f\n", shape.perimeter.to_s )
   printf( "площадь = %.2f\n", shape.square.to_s )
   puts "---------------------------------"
end
