#!/usr/bin/guile -s
!#
(define stdout (current-output-port))
(set-port-encoding! stdout "utf-8")

(define d2 (lambda (f) (/ (round (* f 100.0)) 100.0) ))

(define (point n)         ; ввод и создание точки вершины
   (define x 0) (define y 0) (define z 0+0i)
   (display "вершина № ") (display n) (display " : ")
   (set! x (read))
   (cond ((eof-object? x) x)
      (else 
         (set! y (read))
         (cond ((eof-object? y) y)
            (else (set! z (+ x (* y 0+1i))) z)
         )
      ) 
   )
)

(define (put_point p)     ; вывод точки 
   (display "[" ) (display (d2 (real-part p)))
   (display "," ) (display (d2 (imag-part p))) (display "] " )
)

(define show              ; вывод вершин многоугольника
   (lambda ( lst ) 
   (map (lambda (x) (put_point x)) lst)))

(define (leng x)
   (let loop ((z x) (n 0))
      (if (null? z) n
         (loop (cdr z) (+ 1 n)))))

(define poligon           ; функция ввода кооринат вершин
   (lambda ( n lst )
      (define p 0+0i)
      (set! p (point n))  ; ввод новой вершины 
      (cond ((eof-object? p) (display "\r"))
            (else (set! lst (poligon (+ n  1 ) (cons p lst)))))
      lst
   )      
)

(define perimeter        ; периметр по списку вершин
   (lambda ( lst )
      (define size (lambda (p1 p2) (magnitude (- p1 p2))))
      (define head (car lst))
      (let ploop( (z lst) (per 0.0))
         (if (null? (cdr z ))
            (+ (size (car z) head) per)
            (ploop (cdr z) (+ (size (car z) (car (cdr z ))) per))))
   )
)      
    
(define square           ; площадь по списку вершин
   (lambda (lst)
      (define shead (car lst))
      (define triag (lambda (p1 p2) 
         (set! s1 (- p1 shead))
         (set! s2 (- p2 shead))
         (* (* (abs (sin (- (angle s2) (angle s1)))) 0.5)
            (* (magnitude s1) (magnitude s2)))
      ))
      (define s1 0+0i )
      (define s2 0+0i )
      (let sloop( (z (cdr lst)) (squ 0.0))
         (if (null? (cdr z )) squ
            (sloop (cdr z) (+ (triag (car z) (car (cdr z ))) squ))))
   )
)

(define next              ; цикл по фигурам
   (lambda ()
      (define shape '() )
      (display "координаты вершин в формате: X Y\n" )
      (set! shape (poligon 1 '()) )
      (display "вершин ") (display (leng shape))
      (display " : ") (show shape) (newline)
      (display "периметр = ") (display (d2 (perimeter shape))) (newline) 
      (display "площадь = ") (display (d2 (square  shape))) (newline) 
      (display "---------------------------------\n")
      (next)              ; рекурсия обеспечивает бесконечный цикл
))

(next)                    ; запуск всей программы
